function transform_entity(entity_id, target_entity_name)
  EntityAddComponent2(entity_id, "LuaComponent", {
    script_source_file="mods/play_as_alchemist/transform.lua",
    execute_every_n_frame=1,
    execute_on_added=false,
  })
  EntityAddComponent2(entity_id, "VariableStorageComponent", {
    name="polymorph_target",
    value_string=target_entity_name
  })
  local world_state_entity = GameGetWorldStateEntity()
  local world_state_component = EntityGetFirstComponentIncludingDisabled(world_state_entity, "WorldStateComponent")
  local original_polymorph_count = ComponentGetValue2(world_state_component, "player_polymorph_random_count")
  EntityAddComponent2(entity_id, "VariableStorageComponent", {
    name="original_polymorph_count",
    value_int=original_polymorph_count
  })
end

function OnPlayerSpawned(player_entity)
  transform_entity(player_entity, "alchemist")
end
