dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local var_store_polymorph_target = get_variable_storage_component(entity_id, "polymorph_target")
local target_entity_name = ComponentGetValue2(var_store_polymorph_target, "value_string")
local var_store_original_polymorph_count = get_variable_storage_component(entity_id, "original_polymorph_count")
local original_polymorph_count = ComponentGetValue2(var_store_polymorph_target, "value_int")
local world_state_entity = GameGetWorldStateEntity()
local world_state_component = EntityGetFirstComponentIncludingDisabled(world_state_entity, "WorldStateComponent")
ComponentSetValue2(world_state_component, "player_polymorph_random_count", original_polymorph_count)

local game_effect_component = GetGameEffectLoadTo(entity_id, "POLYMORPH_RANDOM", true)
if game_effect_component > 0 then
  ComponentSetValue2(game_effect_component, "frames", 1)
  local polymorphed_entity_table = EntityGetInRadiusWithTag(x, y, 5, "polymorphed")
  local polymorphed_entity = polymorphed_entity_table[1]
  local x2, y2 = EntityGetTransform(polymorphed_entity)
  local entity_name = EntityGetName(polymorphed_entity)
  if entity_name == "$animal_" .. target_entity_name then
    ComponentSetValue2(game_effect_component, "frames", -1)
    EntityRemoveComponent(entity_id, GetUpdatedComponentID())
    EntityRemoveComponent(entity_id, var_store_polymorph_target)
    EntityRemoveComponent(entity_id, var_store_original_polymorph_count)
	
	-- EntityAddTag( polymorphed_entity, "player_unit" )
	EntityAddTag( polymorphed_entity, "peasant" )
	EntityAddTag( polymorphed_entity, "prey" )
	EntityAddTag( polymorphed_entity, "teleportable" )
	
	EntityRemoveTag( polymorphed_entity, "enemy" )
	EntityRemoveTag( polymorphed_entity, "homing_target" )
	EntityRemoveTag( polymorphed_entity, "teleportable_NOT" )
	EntityRemoveTag( polymorphed_entity, "destruction_target" )
	
	local item_pickupper_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "ItemPickUpperComponent")
	
	EntityRemoveComponent(polymorphed_entity, item_pickupper_component)
	
	EntityAddComponent(polymorphed_entity, "ItemPickUpperComponent", {
		is_in_npc="0",
		drop_items_on_death="0",
	})
	
	
	local hitbox_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "HitboxComponent")
	
	EntityRemoveComponent(polymorphed_entity, hitbox_component)

	EntityAddComponent(polymorphed_entity, "HitboxComponent", {
		_enabled="1",
		aabb_min_x="-3",
		aabb_max_x="3",
		aabb_min_y="-6",
		aabb_max_y="3",
		is_enemy="0",
		is_item="0",
		is_player="1",
	})
	
	EntityAddComponent(polymorphed_entity, "PlatformShooterPlayerComponent", {
		center_camera_on_this_entity="1",
		aiming_reticle_distance_from_character="60",
		camera_max_distance_from_character="50",
		move_camera_with_aim="1",
		-- eating_area_min.x="-6",
		-- eating_area_max.x="6",
		-- eating_area_min.y="-4",
		-- eating_area_max.y="6",
		eating_cells_per_frame="0",
		eating_probability="0",
	})
	
	local platform_shooter_player_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "PlatformShooterPlayerComponent")
	
	ComponentSetValue2(platform_shooter_player_component, "eating_area_min", 0, 0)
	ComponentSetValue2(platform_shooter_player_component, "eating_area_max", 0, 0)
	

	local damage_model_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "DamageModelComponent")
	ComponentSetValue2(damage_model_component, "physics_objects_damage", false)	

	
	-- local character_data_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "CharacterDataComponent")
	
	-- EntityRemoveComponent(polymorphed_entity, character_data_component)

	-- EntityAddComponent(polymorphed_entity, "CharacterDataComponent", {
		-- platforming_type="2",
		-- check_collision_max_size_x="4" ,
		-- check_collision_max_size_y="4" ,
		-- climb_over_y="4" ,
		-- collision_aabb_min_x="-2.0" ,
		-- collision_aabb_max_x="2.0" ,
		-- collision_aabb_min_y="-7.5" ,
		-- collision_aabb_max_y="3" ,
		-- mass="1.3",
		-- eff_hg_offset_y="1.28572" ,
		-- eff_hg_position_x="0" ,
		-- eff_hg_position_y="5" ,
		-- eff_hg_size_x="6.42857" ,
		-- eff_hg_size_y="5.14286" ,
		-- eff_hg_velocity_max_x="19.5787896514" ,
		-- eff_hg_velocity_max_y="-11.5714" ,
		-- eff_hg_velocity_min_x="-19.5714" ,
		-- eff_hg_velocity_min_y="-40" ,
		-- eff_hg_damage_min="10",
		-- eff_hg_damage_max="95",
		-- eff_hg_update_box2d="0",
		-- eff_hg_b2force_multiplier="0.0015",
		-- effect_hit_ground="1" ,
		-- fly_time_max="3.0",
		-- fly_recharge_spd="0.4",
		-- fly_recharge_spd_ground="6",
		-- flying_needs_recharge="1",
		-- flying_in_air_wait_frames="38",
		-- flying_recharge_removal_frames="8",
		-- gravity="0",
		-- buoyancy_check_offset_y="-7",
	-- })
	
	EntityAddComponent(polymorphed_entity, "PhysicsPickUpComponent", {
		-- original_left_joint_pos.x="-8",
		-- original_left_joint_pos.y="-2",
		-- original_right_joint_pos.x="-2",
		-- original_right_joint_pos.y="-2",
		pick_up_strength="400",
	})
	
	local physics_pickup_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "PhysicsPickUpComponent")
	
	ComponentSetValue2(physics_pickup_component, "original_left_joint_pos", -8, -2)
	ComponentSetValue2(physics_pickup_component, "original_right_joint_pos", -2, -2)
	
	-- local animal_ai_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "AnimalAIComponent")
	
	-- EntityRemoveComponent(polymorphed_entity, animal_ai_component)
	
	EntityRemoveComponent(polymorphed_entity, ingest_component)
	
	local controls_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "ControlsComponent")
	
	EntityRemoveComponent(polymorphed_entity, controls_component)
	
	EntityAddComponent2(polymorphed_entity, "ControlsComponent", {
		enabled=true,
		polymorph_hax=true,
		gamepad_fire_on_thumbstick_extend=false,
		gamepad_fire_on_thumbstick_extend_threshold=0.9,
		gamepad_indirect_aiming_enabled=false,
	})	
	EntityAddComponent(polymorphed_entity, "LuaComponent", {
		script_source_file="mods/play_as_alchemist/controls_restore.lua",
		execute_every_n_frame=5,
	}) 
	EntityAddComponent(polymorphed_entity, "MaterialSuckerComponent", {
		suck_gold=1,
		suck_health=1,
	})	
	EntityAddComponent(polymorphed_entity, "Inventory2Component", {
		quick_inventory_slots=10,
		full_inventory_slots_x=16,
		full_inventory_slots_y=1,
	})	
	
	local inventory_full_entity = EntityCreateNew("inventory_full")
	EntityAddChild(polymorphed_entity, inventory_full_entity)
	
	local inventory_quick_entity = EntityCreateNew("inventory_quick")
	EntityAddComponent( inventory_quick_entity, "InheritTransformComponent" )
	EntityAddChild(polymorphed_entity, inventory_quick_entity)
	EntityAddTag( inventory_quick_entity, "player_unit" )
	
	EntityAddComponent(polymorphed_entity, "InventoryGuiComponent", {}) 			
	EntityAddComponent(polymorphed_entity, "WalletComponent", {}) 
	EntityAddComponent(polymorphed_entity, "GunComponent", {}) 
	EntityAddComponent(polymorphed_entity, "AudioListenerComponent", { z = -60, }) 
	EntityAddComponent(polymorphed_entity, "GameLogComponent", {
		report_damage=0,
		report_death=1,
	})
	EntityAddComponent(polymorphed_entity, "GameStatsComponent", {
		is_player=1,
	})
	
    local genome_data_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "GenomeDataComponent")
    ComponentSetValue2(genome_data_component, "herd_id", StringToHerdId("player"))
	
	local character_platforming_component = EntityGetFirstComponentIncludingDisabled(polymorphed_entity, "CharacterPlatformingComponent")
    EntityRemoveComponent(polymorphed_entity, character_platforming_component)
	-- EntityAddComponent2(polymorphed_entity, "CharacterPlatformingComponent", {
		-- animation_to_play="",
		-- jump_keydown_buffer=2 ,
		-- jump_velocity_y=-95 ,
		-- jump_velocity_x=35,
		-- fly_model_player=false,
		-- fly_smooth_y=false,
		-- fly_speed_max_up=95,
		-- fly_speed_max_down=85,
		-- fly_speed_mult=20,
		-- fly_speed_change_spd=0.25,
		-- mouse_look=true ,
		-- keyboard_look=true,
		-- mouse_look_buffer=1 ,
		-- pixel_gravity=350 ,
		-- run_velocity=154,
		-- fly_velocity_x=35 ,
		-- accel_x=0.15 ,
		-- turning_buffer=0.5 ,
		-- velocity_min_x=-35 ,
		-- velocity_max_x=35 ,
		-- velocity_min_y=-200,
		-- velocity_max_y=350,
	-- })
	
	EntityAddComponent2(polymorphed_entity, "CharacterPlatformingComponent", {
		animation_to_play="" ,
		jump_keydown_buffer=2 ,
		jump_velocity_y=-14 ,
		fly_speed_max_up=90,
		fly_speed_max_down=90,
		fly_speed_mult=20,
		fly_speed_change_spd=1,
		mouse_look=false ,
		mouse_look_buffer=1 ,
		pixel_gravity=300 ,
		run_velocity=32 ,
		fly_velocity_x=28 ,
		accel_x=0.3 ,
		turning_buffer=0.1 ,
		velocity_min_x=-50 ,
		velocity_max_x=50 ,
		velocity_min_y=-500,
		velocity_max_y=500,
		run_animation_velocity_switching_enabled=true,
		run_animation_velocity_switching_threshold=50,
	})	
  end
end

-- local effect_component_id = GetGameEffectLoadTo(polymorphed_entity[1], "MOVEMENT_FASTER", true)
-- ComponentSetValue2(effect_component_id, "frames" , -1)